'use strict';

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var _require = require('chai');

const expect = _require.expect;

const Sequelize = require('sequelize');

const createModelAsync = require('./model');

describe('model', () => {
  it('should create new models success', _asyncToGenerator(function* () {
    let modelConfig = {
      database: 'your_database_name',
      username: 'your_database_username',
      password: 'your_database_password',
      host: 'your_database_host',
      dialect: 'mysql', //
      charset: 'utf8mb4',
      pool: {
        max: 5,
        min: 0,
        idle: 10000
      },
      timezone: '+08:00'
    };

    let userModel = {
      id: {
        primaryKey: true,
        type: Sequelize.INTEGER,
        allowNull: false
      },
      name: {
        type: Sequelize.STRING(20),
        allowNull: false
      }
    };
    let models = {
      user: [userModel]
    };

    let toMount = {};
    yield createModelAsync(modelConfig, models, toMount);

    expect(typeof toMount.models.user).to.equal('object');
    expect(typeof toMount.query).to.equal('function');
    expect(typeof toMount.transaction).to.equal('function');

    models = {
      user: userModel
    };
    yield createModelAsync(modelConfig, models, toMount);
    expect(typeof toMount.models.user).to.equal('object');
  }));
});